/*--------------------------文档信息-------------------------------------------
///功能：      进项发票抵扣统计
///创建人：  王群
///创建时间：2011年05月31日
///修改人：  --------------
///修改时间：--------------
///详细说明：--------------
-----------------------------------------------------------------------------*/
//页面全局变量的定义
var strTableP0412 = "Tp0412";     //表格ID
var objSelRowP0412 = {};            //选择行的数据
var intSelRowIDP0412 = 0;         //选择行的ID
var objWhereJsonP0412 = {};     //记录查询时的条件

/*↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓**事件方法 开始**↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓*/
//页面加载的事件
function pageLoad_P0412() {
    try {
        //选择日期范围
        loadDateExtent_P0412();
        //加载收票单位信息
        loadSpdwData_P0412();
        //加载数据
        searchDataClick_P0412();
    } catch (e) { }
}

//查询按钮的事件
function searchDataClick_P0412() {
    try {
        var strWhereJson = "";      //存放当前的查询条件
        var objConfig = {};              //存放当前的列配置
        var objResult = {};              //存放当前的查询结果

        if (!$("#cmbSpdwP0412").combobox("getValue")) {        //当前选择的客户不存在，赋值为【全部收票单位】！
            $("#cmbSpdwP0412").combobox("setValue", "");
        }
        //清空选择行信息
        intSelRowIDP0411 = 0;
        objSelRowP0411 = {};
        //查询条件的取得
        strWhereJson = "{\"sdate\":\"" + $("#dateStartTimeP0412").val() + "\",";
        strWhereJson += "\"edate\":\"" + $("#dateEndTimeP0412").val() + "\",";
        strWhereJson += "\"kpdwdm\":\"" + $("#cmbSpdwP0412").combobox("getValue") + "\"}";
        //记录查询条件
        objWhereJsonP0412 = ParseData(strWhereJson.replace("}",
        ",\"dname\":\"" + $("#cmbDateExtentP0412").combobox("getValue") + "\",\"kpdwmc\":\"" + $("#cmbSpdwP0412").combobox("getText") + "\"}"));

        objConfig = ParseData(window.external.DoOptions(strTableP0412, "GetTableConfig", "{}"));
        //格式化数据
        setData_P0412(objConfig.colModel);
        //创建表格
        objResult = ParseData(window.external.DoOptions(strTableP0412, "GetList", strWhereJson));
        createGrid_P0412(strTableP0412, objConfig.colNames, objConfig.colModel, objResult.Records);

        //释放内存
        strWhereJson = null;
        objConfig = null;
        objResult = null;
    } catch (e) { }
}

//日期范围修改方法
function dateTimeChange_P0412() {
    if ($("#cmbDateExtentP0412").combobox("getText") != "自定义") {
        $("#cmbDateExtentP0412").combobox("setValue", "");
        $("#cmbDateExtentP0412").combobox("setText", "自定义");
    }
}

//查看明细按钮事件
function viewDetail_P0412() {
    if (intSelRowIDP0412 > 0) {
        //改变标签的Name 
        $(window.parent.document).find("#span_412").text("抵扣明细");

        //选择的日期
        $(window.parent.document).find("#idIframe-41201").attr("dname", objWhereJsonP0412.dname);
        $(window.parent.document).find("#idIframe-41201").attr("sdate", objWhereJsonP0412.sdate);
        $(window.parent.document).find("#idIframe-41201").attr("edate", objWhereJsonP0412.edate);

        //收票单位
        $(window.parent.document).find("#idIframe-41201").attr("kpdwdm", objSelRowP0412.kpdwdm ? objSelRowP0412.kpdwdm : objWhereJsonP0412.kpdwdm);
        $(window.parent.document).find("#idIframe-41201").attr("kpdwmc", objSelRowP0412.kpdwdm ? objSelRowP0412.kpdwmc : objWhereJsonP0412.kpdwmc);

        //改变标签Iframe的Src
        $(window.parent.document).find("#idIframe-412").css("display", "none"); //隐藏统计页面
        $(window.parent.document).find("#idIframe-41201").css("display", ""); //显示明页面
        $(window.parent.document).find("#idIframe-41201").attr("src", "04/p041201.htm");

        //调整iframe的高度
        $(window.parent.document).find("#idIframe-41201").load(function () {
            var iHeight = window.parent.document.documentElement.clientHeight - window.parent._iFrmHeight;
            $(this).height(iHeight);
        });
    }
    else {
        //"请选择数据！"
        window.parent.cihoAlert(msg.other.selDataRow);
    }
}
/*↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓**事件方法 结束**↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓*/


/*↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓**自定义方法 开始**↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓*/
//格式化表格中的数据
function setData_P0412(objP0412) {
    for (var i = 0; i < objP0412.length; i++) {
        if (objP0412[i].name == "fpje" || objP0412[i].name == "dkje") {   //money的格式化
            objP0412[i].formatter = formatterP0412Money;
        }
        if (objP0412[i].name == "fpsl") {   //数量的格式化
            objP0412[i].formatter = formatterP0412Count;
        }
        if (objP0412[i].name == "dksl") {   //百分比的格式化
            objP0412[i].formatter = formatterP0412Percent;
        }
    }
}

//选择日期范围
function loadDateExtent_P0412() {
    //设置默认日期为本月
    dateExtentCalculation("本月", "dateStartTimeP0412", "dateEndTimeP0412");

    //添加选择事件
    $("#cmbDateExtentP0412").combobox({
        width: _iWidth100,
        listWidth: _iWidth100,
        valueField: "dm",
        textField: "mc",
        panelHeight: 102,
        editable: false,
        onSelect: function (option) {
            dateExtentCalculation(option.dm, "dateStartTimeP0412", "dateEndTimeP0412");
        },
        enterDown: function () {
            dateExtentCalculation($("#cmbDateExtentP0412").combobox("getValue"), "dateStartTimeP0412", "dateEndTimeP0412");
        }
    });
    //加载数据
    $("#cmbDateExtentP0412").combobox("loadData", [{ dm: "本月", mc: "本月", selected: true }, { dm: "上一月", mc: "上一月" }, { dm: "本周", mc: "本周" }, { dm: "过去三个月", mc: "过去三个月" }, { dm: "本年", mc: "本年"}]);
}

//给售票单位加载数据
function loadSpdwData_P0412() {
    $("#cmbSpdwP0412").combobox({
        width: _iWidth120,
        listWidth: _iWidth120,
        valueField: "dm",
        textField: "mc",
        onblur: function () {
            if ($("#cmbSpdwP0412").combobox("getText") == "") {
                $("#cmbSpdwP0412").combobox("setValue", "");
            }
        },
        onfocus: function () {
            if ($("#cmbSpdwP0412").combobox("getText") == "全部收票单位") {
                $("#cmbSpdwP0412").combobox("setText", "");
            }
        },
        enterDown: function () { }
    });

    //加载数据
    var objDrug = getComboboxData("Tkpdwxx2");
    if (objDrug == "{}") {
        objDrug = [];
    }
    objDrug.unshift({ "dm": "", "mc": "全部收票单位", "selected": true });
    $("#cmbSpdwP0412").combobox("loadData", objDrug);
    //释放内存
    objDrug = null;
}

//计算合计行
function totalCompute_P0412() {
    var strDkfpsl = parseFloat($("#" + strTableP0412).getCol("fpsl", false, "sum")).toFixed(window.parent.strCountPlace);
    var strFpMoney = parseFloat($("#" + strTableP0412).getCol("fpje", false, "sum")).toFixed(window.parent.strMoneyPlace);
    var strDkMoney = parseFloat($("#" + strTableP0412).getCol("dkje", false, "sum")).toFixed(window.parent.strMoneyPlace);
    var intIDLength = $("#" + strTableP0412).getDataIDs();
    if (intIDLength.length > 0) {                          //表格中有记录的时候，合计行中的数据正常格式化
        $("#" + strTableP0412).footerData("set", { rn: "合计", fpsl: strDkfpsl, fpje: strFpMoney, dkje: strDkMoney }, true);
    }
    else {                                                              //表格中没有记录的时候，合计行中的数据格式化成空
        $("#" + strTableP0412).footerData("set", { rn: "合计", fpsl: "&nbsp;", fpje: "&nbsp;", dkje: "&nbsp;" }, false);
    }
}

//money格式化方法
function formatterP0412Money(cellvalue, options, rowObject) {
    if (isNaN(parseFloat(cellvalue))) {
        cellvalue = 0;
    }
    return parseFloat(cellvalue).toFixed(window.parent.strMoneyPlace);
}

// 百分比的格式化方法
function formatterP0412Percent(cellvalue, options, rowObject) {
    if (isNaN(parseFloat(cellvalue))) {
        cellvalue = 0;
    }
    return (parseFloat(cellvalue) * 100).toFixed(window.parent.strPercentPlace) + "%";
}

//数量的格式化方法
function formatterP0412Count(cellvalue, options, rowObject) {
    if (isNaN(parseFloat(cellvalue))) {
        cellvalue = 0;
    }
    return parseFloat(cellvalue).toFixed(window.parent.strCountPlace);
}

//当基本资料数据有修改时 刷新相关的combobox方法
function refreshMyCombobox(strModels) {
    if ($(window.parent.document).find('#idIframe-41201').length > 0) {
        $(window.parent.document.getElementById("idIframe-41201").contentWindow.document.getElementById("idRefreshCombobox")).val(strModels[0]);
        $(window.parent.document.getElementById("idIframe-41201").contentWindow.document.getElementById("idRefreshCombobox")).click();
    }
    for (var i = 0; i < strModels.length; i++) {
        var data = getComboboxData(strModels[i] + "2");

        if (strModels[i] == "Tkpdwxx") {
            data.unshift({ dm: "", mc: "全部收票单位", "selected": true });
            reLoadCombobox("cmbSpdwP0412", data);
        }
    }
}

/*↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓**自定义方法 结束**↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓*/
/*-------------------------------------------------------------
功能：创建普通表格
*****①strTableID：表格的ID
*****②objColNames:表格需要显示的列名
*****③objColModel：表格的列配置
*****④objDataRecords：表格中需要加载的数据
-----------------------------------------------------------------*/
function createGrid_P0412(strTableID, objColNames, objColModel, objDataRecords) {
    $("#" + strTableID).GridUnload();       //删除旧表格
    if (objDataRecords == "{}") {              //当前数据源为空时，设置数据源变量为空对象
        objDataRecords = [];
    }
    //生成表格
    $("#" + strTableID).jqGrid({
        datatype: "local",
        sortname: "id",
        colNames: objColNames,
        colModel: objColModel,
        data: objDataRecords,
        rownumbers: true,
        autowidth: true,
        footerrow: true,
        gridview: true,
        rownumWidth: 30,
        cellsubmit: "clientArray",
        rowNum: objDataRecords.length,
        onSelectRow: function (rowId) {//当前选择行数据取得
            intSelRowIDP0412 = rowId;
            objSelRowP0412 = $(this).getRowData(rowId);
        },
        ondblClickRow: function () {
            viewDetail_P0412();
        }
    }).parent(".ui-jqgrid-bdiv").siblings().css("width", "100%");

    //设置行号列的名称
    //$("table.ui-jqgrid-htable th:first", $("#gbox_" + strTableID)).text("序号");
    $("#" + strTableID).setLabel("rn", "序号");

    //调整表格的大小
    resizeGrid(strTableP0412, true, false);
    //有滚动条时改变表格宽度
    resizeGridScroll(strTableP0412);
    //合计数据的计算
    totalCompute_P0412();
}